close all; clear all;
gr=groot;gr.ShowHiddenHandles='on';
fig=uifigure;
fig.Position = [10 100 900 850];
sub22(1)=uiaxes(fig);
sub22(2)=uiaxes(fig);
sub22(3)=uiaxes(fig);
sub22(4)=uiaxes(fig);
set(sub22(1),'Position',[73.8000 246.2116 187.4091 143.2884]);
set(sub22(2),'Position',[320.3909 246.2116 187.4091 143.2884]);
set(sub22(3),'Position',[73.8000 47.2000 187.4091 143.2884]);
set(sub22(4),'Position',[320.3909 47.2000 187.4091 143.2884]);
viewagl=[-37.5,30;0,90;90,0;0,0];

% << 右腕 >>
% <肩>
arm( 1).l=[-2;0;0];	arm( 1).a=[-1;0;0];	arm( 1).limit=[-pi/4, pi];		arm(1).label='肩';
arm( 2).l=[-1;0;0];	arm( 2).a=[0;-1;0];	arm( 2).limit=[-pi/2, pi/2];	arm(2).label='肩';
arm( 3).l=[0;0;0];	arm( 3).a=[0;0;1];	arm( 3).limit=[-pi/2, pi/2];	arm(3).label='肩';
% <ひじ>
arm( 4).l=[0;0;-2];	arm( 4).a=[-1;0;0];	arm( 4).limit=[0, pi*5/6];		arm(4).label='ひじ';
% <手首>
arm( 5).l=[0;0;-3];	arm( 5).a=[0;0;1];	arm( 5).limit=[-pi/2, pi/2];	arm(5).label='手首';
arm( 6).l=[0;0;0];	arm( 6).a=[0;-1;0];	arm( 6).limit=[-pi/2, pi/2];	arm(6).label='手首';
for i=1:6
	arm(i).th = 0;
	arm(i).parent = i-1;
end
% <手指>
arm( 7).l=[0;-0.5;-0.5];	arm( 7).a=[1;-1;0.5];		arm( 7).label='親指';
arm(10).l=[0;-0.25;-0.9];	arm(10).a=[0.1;-1;0.1];		arm(10).label='人差し指';
arm(14).l=[0;0;-1];			arm(14).a=[0;-1;0];			arm(14).label='中指';
arm(18).l=[0;0.25;-0.9];	arm(18).a=[-0.1;-1;-0.1];	arm(18).label='薬指';
arm(22).l=[0;0.5;-0.7];		arm(22).a=[-0.3;-1;-0.1];	arm(22).label='小指';
for i=7:25
	arm(i).th=0;
	arm(i).limit=[0, pi/2];
	if any(i == [7,10,14,18,22])
		arm(i).parent=6;
	else
		arm(i).l=[0;0;-1] / 4;
		arm(i).a=arm(i-1).a;
		arm(i).label=arm(i-1).label;
		arm(i).parent=i-1;
	end
end
arm(7).limit = [0,pi/3];

% << 左腕 >>
% <肩>
arm(26).l=[2;0;0];	arm(26).a=[-1;0;0];	arm(26).limit=[-pi/4, pi];		arm(26).label='肩';
arm(27).l=[1;0;0];	arm(27).a=[0;1;0];	arm(27).limit=[-pi/2, pi/2];	arm(27).label='肩';
arm(28).l=[0;0;0];	arm(28).a=[0;0;-1];	arm(28).limit=[-pi/2, pi/2];	arm(28).label='肩';
% <ひじ>
arm(29).l=[0;0;-2];	arm(29).a=[-1;0;0];	arm(29).limit=[0, pi*5/6];		arm(29).label='ひじ';
% <手首>
arm(30).l=[0;0;-3];	arm(30).a=[0;0;-1];	arm(30).limit=[-pi/2, pi/2];	arm(30).label='手首';
arm(31).l=[0;0;0];	arm(31).a=[0;1;0];	arm(31).limit=[-pi/2, pi/2];	arm(31).label='手首';
arm(26).th = 0; arm(26).parent = 0;
for i=27:31
	arm(i).th = 0;
	arm(i).parent = i-1;
end
% <手指>
for i=32:50
	arm(i).th=0;
	arm(i).limit=[0, pi/2];
	if any(i == [32,35,39,43,47])
		arm(i).l = arm(i-25).l;  %左手と同じ
		arm(i).a = arm(i-25).a .* [1;-1;-1];  %左手指の軸を対称移動
		arm(i).label = arm(i-25).label;
		arm(i).parent=31;
	else
		arm(i).a=arm(i-1).a;
		arm(i).l=[0;0;-1] / 4;
		arm(i).label = arm(i-1).label;
		arm(i).parent=i-1;
	end
end

arm=vectest9makechildlink(arm);
ind=vectest9findallchildren(arm);
arm=vectest9kinematics(arm,ind);
plot1=[];
plot1=vectest9plot2021(arm,plot1,sub22);

% 顔、目、体は動かないので直方体でプロット
x=[0,1,1,0,0];x=[x,x];
y=[0,0,1,1,0];y=[y,y];
z=[zeros(1,5),ones(1,5)];
x=[x,nan,x([2,2]) nan,x([3,3]),nan,x([4,4]),nan];
y=[y,nan,y([2,2]) nan,y([3,3]),nan,y([4,4]),nan];
z=[z,[nan,0,1,nan,0,1,nan,0,1,nan]];
xyz = [x;y;z];
head = (xyz-0.5) .* [repelem(1.5,20); repelem(1,20); repelem(2,20)] + [zeros(1,20); zeros(1,20); ones(1,20)];
eye1 = (xyz-0.5) .* [repelem(0.3,20); repelem(0.1,20); repelem(0.3,20)] + [repelem(0.3,20); repelem(-0.6,20); repelem(1.5,20)];
eye2 = (xyz-0.5) .* [repelem(0.3,20); repelem(0.1,20); repelem(0.3,20)] + [repelem(-0.3,20); repelem(-0.6,20); repelem(1.5,20)];
body = (xyz-0.5) .* [repelem(4,20); repelem(1.6,20); repelem(4,20)] + [zeros(1,20); zeros(1,20); repelem(-2,20)];

for j=1:4
	hold(sub22(j),'on');
	plot3(sub22(j),head(1,:),head(2,:),head(3,:),'-b');
	plot3(sub22(j),eye1(1,:),eye1(2,:),eye1(3,:),'-b');
	plot3(sub22(j),eye2(1,:),eye2(2,:),eye2(3,:),'-b');
	plot3(sub22(j),body(1,:),body(2,:),body(3,:),'-b');
	hold off;
end


fig2=uifigure;
fig2.Position = [900 250 420 540];
[ui, buttons]=vectest9makeui2021(arm,'vectest9sub2021;',fig2);


